{
  description = "IPFS deploy tool";

  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/release-22.11";
    utils.url = "github:numtide/flake-utils";
    naersk.url = "github:nix-community/naersk";
  };

  outputs = { self, nixpkgs, utils, naersk }:
    utils.lib.eachDefaultSystem (system:
      let
        pkgs = nixpkgs.legacyPackages."${system}";
        naersk-lib = naersk.lib."${system}";
      in
      rec {
        # `nix build`
        packages.marvin = naersk-lib.buildPackage {
          pname = "marvin";
          root = ./.;
        };
        packages.default = packages.marvin;

        # `nix run`
        apps.marvin = utils.lib.mkApp {
          drv = packages.marvin;
        };
        apps.default = apps.marvin;

        # `nix develop`
        devShells.default = pkgs.mkShell {
          name = "marvin";
          nativeBuildInputs = with pkgs; [ libiconv rustup rust-analyzer ];
        };
      });
}
